import scala.language.implicitConversions

class Logger[T](val value : T) {
  def |>[T2](f: T => T2) = {
    println(s"logging: $value")
    f(value)
  }
}

object Logger {
  def apply[T](value : T) = new Logger(value)
}

implicit def convertToLogger[T](value : T) = new Logger(value)

def ignore[T](value: T) {}

Logger(4) |> { _ * 2.2 } |> { _ + 10 } |> ignore

println("using implicit conversion")
2 |> { _ * 2.2 } |> { _ + 10 } |> ignore