trait Friend {
  val name:String
  def listen() = println(s"I'm $name, listening...")
}

trait Curious {
  def pokeAround() = println("...cursious...")
}

class Human(val name: String) extends Friend
class Dog(val name: String) extends Friend with Curious
class Cat(val name: String)

val sam = new Human("Sam")
val buddy = new Dog("Buddy")

def seekHelpFrom(friend: Friend) = friend.listen()
  
seekHelpFrom(sam)
seekHelpFrom(buddy)

val alf = new Cat("Alf")
// seekHelpFrom(alf) //ERROR

val tac = new Cat("Tac") with Friend with Curious
seekHelpFrom(tac)

buddy.pokeAround()
tac.pokeAround()